<script setup lang="ts">
import type { Header, Item, ServerOptions } from "vue3-easy-data-table";
import Swal from 'sweetalert2'
import { useFormStore } from "@/stores/forms"
import { onMounted, ref, watch } from "vue";
import { useI18n } from 'vue-i18n'
import StaffCreateModal from './components/StaffCreateModal.vue'
const { t, locale } = useI18n()


const openShowModal = ref(false)

const formStore = useFormStore()

const loading = ref(false);
const serverItemsLength = ref(0);
const serverOptions = ref<ServerOptions>({
    page: 1,
    rowsPerPage: 5
});

const openModal = () => {
    openShowModal.value = !openShowModal.value
}
console.log(locale.value);


const deleteForm = (id: number) => {
    console.log(id);
    Swal.fire({
        title: 'Are you sure?',
        text: "You won't be able to revert this!",
        icon: 'warning',
        showCancelButton: true,
        confirmButtonColor: '#3085d6',
        cancelButtonColor: '#d33',
        confirmButtonText: 'Yes, delete it!'
    }).then((result) => {
        if (result.isConfirmed) {
            console.log(result);

        }
    })
}

async function getListForm() {
    loading.value = true;
    await formStore.getAllFormsList({ page: serverOptions.value.page, limit: serverOptions.value.rowsPerPage })
    serverItemsLength.value = formStore.getFormsList.data.total_count
    loading.value = false;
}

onMounted(() => {
    getListForm()

})

const headers: Header[] = [
    { text: "id", value: "id" },
    { text: "avatar", value: "avatar" },
    { text: "name_two", value: "ism" },
    { text: "username", value: "username" },
    { text: "role", value: "role" },
    { text: "Status", value: "status" },
    { text: "actions", value: "actions" },

];

const headerItemClassNameFunction = (header): string => {
    if (header.value === "actions") return "float-right mr-12";
    return "";
};


watch(
    serverOptions,
    (value) => {
        getListForm();
    },
    { deep: true }
);

</script>

<template>
    <div>
        <div class="flex items-center gap-2 uk-card uk-card-small uk-card-default uk-card-body rounded my-2">
            <div class="w-1/4">
                <label for="search">
                    {{ t('Search') }}
                    <input id="search" type="text" class="form-input" :placeholder="t('Search')">
                </label>
            </div>

            <div class="w-1/4">
                <label for="status">
                    {{ t('Status') }}
                    <v-select id="status" :options="books" label="title" class="!rounded-md mt-1"
                        :placeholder="t('Status')" />
                </label>
            </div>

            <div class="w-1/4">
                <label for="type_form">
                    {{ t('account_type_status') }}
                    <v-select id="type_form" label="title" class="!rounded-md mt-1"
                        :placeholder="t('account_type_status')" />
                </label>
            </div>


        </div>
        <div class="flex items-center mb-2 ">
            <button class="btn-success w-1/12 ml-auto" @click="openModal()">{{ t('Add') }}</button>
        </div>
        <div>
            <!-- {{ formStore.getFormsList.data.total_count }} -->
            <EasyDataTable buttons-pagination v-model:server-options="serverOptions" theme-color="#7367f0"
                :server-items-length="serverItemsLength" :loading="loading" id="user-table"
                :header-item-class-name="headerItemClassNameFunction" :headers="headers" items="" :rows-items="[5, 10, 15]"
                :rows-per-page="10">

                <template #empty-message>
                    <span>{{ t('empty_text') }}</span>
                </template>
                <template #header="data">
                    {{ t(data.text) }}
                </template>

                <template #item-name="item">
                    {{ item.name[locale.valueOf()] }}
                </template>

                <template #item-actions="item">
                    <div class="flex items-center justify-end gap-2">
                        <button class="btn-warning btn-action">
                            <span uk-icon="icon: pencil" class="uk-icon"></span>
                        </button>
                        <button class="btn-danger btn-action" @click="deleteForm(item.id)">
                            <span uk-icon="icon: trash" class="uk-icon"></span>
                        </button>
                    </div>
                </template>
            </EasyDataTable>
        </div>


        <StaffCreateModal @openModal="openModal" :openShowModal="openShowModal" />
    </div>
</template>

<style>
.vue3-easy-data-table__loading-mask[data-v-19cc4b1b] {
    background-color: rgba(0, 0, 0, 0.1);
}
</style>